VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "PC/SC Sample Application"
   ClientHeight    =   4995
   ClientLeft      =   3390
   ClientTop       =   3015
   ClientWidth     =   5745
   ControlBox      =   0   'False
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4995
   ScaleWidth      =   5745
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton butExit 
      Cancel          =   -1  'True
      Caption         =   "Exit"
      Height          =   375
      Left            =   4350
      TabIndex        =   10
      Top             =   4470
      Width           =   1215
   End
   Begin VB.CommandButton BtnGetAttrib 
      Caption         =   "Get&Attributes"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4260
      TabIndex        =   9
      Top             =   720
      Width           =   1335
   End
   Begin VB.CommandButton BtnClearContents 
      Caption         =   "C&learContent"
      Height          =   375
      Left            =   2970
      TabIndex        =   8
      Top             =   4470
      Width           =   1215
   End
   Begin VB.ComboBox CommandCombo 
      Enabled         =   0   'False
      Height          =   315
      Left            =   1200
      TabIndex        =   7
      Top             =   1260
      Width           =   4365
   End
   Begin VB.CommandButton BtnTransmit 
      Caption         =   "&Transmit"
      Enabled         =   0   'False
      Height          =   375
      Left            =   2880
      TabIndex        =   6
      Top             =   720
      Width           =   1335
   End
   Begin VB.CommandButton CardConnect 
      Caption         =   "&CardConnect"
      Enabled         =   0   'False
      Height          =   375
      Left            =   120
      TabIndex        =   5
      Top             =   720
      Width           =   1335
   End
   Begin VB.CommandButton CardDisconnect 
      Caption         =   "Card&Disconnect"
      Enabled         =   0   'False
      Height          =   375
      Left            =   1500
      TabIndex        =   4
      Top             =   720
      Width           =   1335
   End
   Begin RichTextLib.RichTextBox Message 
      DataSource      =   "False"
      Height          =   2595
      Left            =   120
      TabIndex        =   2
      Top             =   1740
      Width           =   5445
      _ExtentX        =   9604
      _ExtentY        =   4577
      _Version        =   393217
      BorderStyle     =   0
      Enabled         =   -1  'True
      HideSelection   =   0   'False
      ReadOnly        =   -1  'True
      ScrollBars      =   3
      TextRTF         =   $"frmMain.frx":0000
   End
   Begin VB.ComboBox ReaderListCombo 
      Height          =   315
      Left            =   1560
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   240
      Width           =   4005
   End
   Begin VB.Label LblCommand 
      Caption         =   "Command"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   1260
      Width           =   975
   End
   Begin VB.Label ReaderListLabel 
      Caption         =   "Select a Reader :"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   1335
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public hContext   As Long
Public szReaderName As String
Public nReaderCount As Long
Public lResult As Long
Public hCard As Long
Public szMessage As String
Public lMode As Long
Public lProtocol As Long
Public bConversion As Boolean
Public lDisconnectOption As Long
Public szProtocol As String

Private Function StringToBytArray(command As String) As BytArray
    Dim iLen As Integer
    Dim szTemp As String
    Dim btArrTemp As BytArray
    Dim iLower As Integer, iUpper As Integer
    
    szTemp = UCase(CommandCombo.Text)
    iLen = Len(szTemp)
    If iLen Mod 2 <> 0 Or iLen = 0 Then
        MsgBox "Please Check the command that you have entered.", vbCritical + vbOKOnly
        bConversion = False
        Exit Function
    End If
    
    Dim i As Integer
    Dim count As Long
    
    i = 1
    count = 0
    While i <= iLen
        iLower = -1
        iUpper = -1
        On Error Resume Next
        iUpper = CInt(Mid(szTemp, i, 1))
        If iUpper = -1 Then
            iUpper = Asc(Mid(szTemp, i, 1)) - 55
            If iUpper >= 16 Then
                MsgBox "Invalid Charcter entered", vbCritical + vbOKOnly
                bConversion = False
                Exit Function
            End If
        End If
        On Error Resume Next
        iLower = CInt(Mid(szTemp, i + 1, 1))
        If iLower = -1 Then
            iLower = Asc(Mid(szTemp, i + 1, 1)) - 55
            If iLower >= 16 Then
                MsgBox "Invalid Charcter entered", vbCritical + vbOKOnly
                bConversion = False
                Exit Function
            End If
        End If
        i = i + 2
        btArrTemp.byBytes(count) = iUpper * 16 + iLower
        count = count + 1
    Wend
    
    StringToBytArray = btArrTemp
    bConversion = True
End Function

Private Sub BtnClearContents_Click()
    Message.Text = ""
    CommandCombo.Clear
End Sub

Private Sub BtnGetAttrib_Click()
    Dim bytRecvAttr As BytArray
    Dim lRecLen As Long
    Dim lTemp As Long
    Dim szTemp As String
    Dim i As Integer
        
    '  Getting vendor name
    lRecLen = 255
    lResult = SCardGetAttrib(hCard, SCARD_ATTR_VENDOR_NAME, bytRecvAttr, lRecLen)
    If lResult <> SCARD_S_SUCCESS Then
        MsgBox "Failed to get Vendor Name"
    Else
        szMessage = "VendorName    : " + BytArrayToString(bytRecvAttr, lRecLen) + vbNewLine
        Message.Text = szMessage
    End If
    
    ' Getting vendor IFD type
    lRecLen = 255
    lResult = SCardGetAttrib(hCard, SCARD_ATTR_VENDOR_IFD_TYPE, bytRecvAttr, lRecLen)
    If lResult <> SCARD_S_SUCCESS Then
        MsgBox "Failed to get IFD Type"
    Else
        szMessage = "IFD Type          : " + BytArrayToString(bytRecvAttr, lRecLen) + vbNewLine
        Message.Text = Message.Text + szMessage
    End If
    
    '   Getting IFD version
    lRecLen = 255
    lResult = SCardGetAttrib(hCard, SCARD_ATTR_VENDOR_IFD_VERSION, bytRecvAttr, lRecLen)
    If lResult <> SCARD_S_SUCCESS Then
        MsgBox "Failed to get IFD Version"
    Else
        i = lRecLen - 1
        szTemp = bytRecvAttr.byBytes(2) & "." & bytRecvAttr.byBytes(3) & "." & bytRecvAttr.byBytes(1) & "." & bytRecvAttr.byBytes(0)
        szMessage = "IFD Version      : " + szTemp + vbNewLine
        Message.Text = Message.Text + szMessage
    End If
     
    ' Getting channel ID
    lRecLen = 255
    lResult = SCardGetAttrib(hCard, SCARD_ATTR_CHANNEL_ID, bytRecvAttr, lRecLen)
    If lResult <> SCARD_S_SUCCESS Then
        MsgBox "Failed to get channel ID"
    Else
        i = 0
        szTemp = ""
        lTemp = 0
        While i < lRecLen
            lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
            i = i + 1
        Wend
        lTemp = lTemp And &HFFFF0000
        
        szTemp = ""
        Select Case lTemp
            Case &H10000
                szTemp = "Serial," + Trim(Str(Hex(lTemp)))
            Case &H20000
                szTemp = "Parallel," + Trim(Str(Hex(lTemp)))
            Case &H40000
                szTemp = "PS/2," + Trim(Str(Hex(lTemp)))
            Case &H80000
                szTemp = "SCSI," + Trim(Str(Hex(lTemp)))
            Case &H100000
                szTemp = "IDE," + Trim(Str(Hex(lTemp)))
            Case &H200000
                szTemp = "USB," + Trim(Str(Hex(lTemp)))
            Case &H400000
                szTemp = "PCMCIA," + Trim(Str(Hex(lTemp)))
            Case Else
                szTemp = "Unknown Channel," + Trim(Str(Hex(lTemp)))
        End Select
        szMessage = "Channel  ID      : " + szTemp + vbNewLine
        Message.Text = Message.Text + szMessage
    End If
    
    ' Getting Default clock
    lRecLen = 255
    lResult = SCardGetAttrib(hCard, SCARD_ATTR_DEFAULT_CLK, bytRecvAttr, lRecLen)
    If lResult <> SCARD_S_SUCCESS Then
        MsgBox "Failed to get Default Clock"
    Else
        i = 0
        szTemp = ""
        lTemp = 0
        While i < lRecLen
            lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
            i = i + 1
        Wend
        
        szMessage = "Default clock    : " + Str(lTemp) + vbNewLine
        Message.Text = Message.Text + szMessage
    End If
    
    ' Getting default data rate
    
    lRecLen = 255
    lResult = SCardGetAttrib(hCard, SCARD_ATTR_DEFAULT_DATA_RATE, bytRecvAttr, lRecLen)
    If lResult <> SCARD_S_SUCCESS Then
        MsgBox "Failed to get Default Data rate"
    Else
        i = 0
        szTemp = ""
        lTemp = 0
        While i < lRecLen
            lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
            i = i + 1
        Wend
        
        szMessage = "Def. data rate   : " + Str(lTemp) + vbNewLine
        Message.Text = Message.Text + szMessage
    End If
    
    ' Getting max clock rate
    lRecLen = 255
    lResult = SCardGetAttrib(hCard, SCARD_ATTR_MAX_CLK, bytRecvAttr, lRecLen)
    If lResult <> SCARD_S_SUCCESS Then
        MsgBox "Failed to get Max Clock"
    Else
        i = 0
        szTemp = ""
        lTemp = 0
        While i < lRecLen
            lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
            i = i + 1
        Wend
        
        szMessage = "Max Clock        : " + Str(lTemp) + vbNewLine
        Message.Text = Message.Text + szMessage
    End If
    
    ' Getting max data rate
    lRecLen = 255
    lResult = SCardGetAttrib(hCard, SCARD_ATTR_MAX_DATA_RATE, bytRecvAttr, lRecLen)
    If lResult <> SCARD_S_SUCCESS Then
        MsgBox "Failed to get Max Data rate"
    Else
        i = 0
        szTemp = ""
        lTemp = 0
        While i < lRecLen
            lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
            i = i + 1
        Wend
        
        szMessage = "Max Data rate  : " + Str(lTemp) + vbNewLine
        Message.Text = Message.Text + szMessage
    End If
    
    ' Getting IFSD
    lRecLen = 255
    lResult = SCardGetAttrib(hCard, SCARD_ATTR_MAX_IFSD, bytRecvAttr, lRecLen)
    If lResult <> SCARD_S_SUCCESS Then
        MsgBox "Failed to get Max IFSD"
    Else
        i = 0
        szTemp = ""
        lTemp = 0
        While i < lRecLen
            lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
            i = i + 1
        Wend
        
        szMessage = "Max IFSD         : " + Str(lTemp) + vbNewLine
        Message.Text = Message.Text + szMessage
    End If
    
    ' Getting card status
    lRecLen = 255
    lResult = SCardGetAttrib(hCard, SCARD_ATTR_ICC_PRESENCE, bytRecvAttr, lRecLen)
    If lResult <> SCARD_S_SUCCESS Then
        MsgBox "Failed to get Card Status"
    Else
        i = 0
        szTemp = ""
        Dim bCardStatus As Boolean
        bCardStatus = False
        lTemp = 0
        While i < lRecLen
            lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
            i = i + 1
        Wend
        If (lTemp And &HFF) = 0 Then
            szTemp = "Removed"
            bCardStatus = False
        Else
            szTemp = "Inserted"
            bCardStatus = True
        End If
        szMessage = "Card status       : " + szTemp + vbNewLine
        Message.Text = Message.Text + szMessage
    End If
    
    If bCardStatus Then
        ' Getting ATR
        lRecLen = 255
        lResult = SCardGetAttrib(hCard, SCARD_ATTR_ATR_STRING, bytRecvAttr, lRecLen)
        If lResult <> SCARD_S_SUCCESS Then
            MsgBox "Failed to get ATR"
        Else
            szMessage = "ATR                 : " + DecimalToString(bytRecvAttr, lRecLen, True) + vbNewLine
            Message.Text = Message.Text + szMessage
        End If
    
        ' Getting protocol
        szMessage = "Protocol           : " + szProtocol + vbNewLine
        Message.Text = Message.Text + szMessage
        
        ' Getting current block
        lRecLen = 255
        lResult = SCardGetAttrib(hCard, SCARD_ATTR_CURRENT_CLK, bytRecvAttr, lRecLen)
        If lResult <> SCARD_S_SUCCESS Then
            MsgBox "Failed to get Current Clock rate"
        Else
            i = 0
            szTemp = ""
            lTemp = 0
            While i < lRecLen
                lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
                i = i + 1
            Wend
            
            szMessage = "Current Clock   : " + Str(lTemp) + vbNewLine
            Message.Text = Message.Text + szMessage
        End If
        
        ' Getting current clock rate conversion factor (F)
        lRecLen = 255
        lResult = SCardGetAttrib(hCard, SCARD_ATTR_CURRENT_F, bytRecvAttr, lRecLen)
        If lResult <> SCARD_S_SUCCESS Then
            MsgBox "Failed to get Current Clock rate conversion factor"
        Else
            i = 0
            szTemp = ""
            lTemp = 0
            While i < lRecLen
                lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
                i = i + 1
            Wend
            
            szMessage = "Current F          : " + Str(lTemp) + vbNewLine
            Message.Text = Message.Text + szMessage
        End If
        
        ' Getting current buad rate conversion factor (D)
        lRecLen = 255
        lResult = SCardGetAttrib(hCard, SCARD_ATTR_CURRENT_D, bytRecvAttr, lRecLen)
        If lResult <> SCARD_S_SUCCESS Then
            MsgBox "Failed to get Current baud rate conversion factor"
        Else
            i = 0
            szTemp = ""
            lTemp = 0
            While i < lRecLen
                lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
                i = i + 1
            Wend
            
            szMessage = "Current D          : " + Str(lTemp) + vbNewLine
            Message.Text = Message.Text + szMessage
        End If
        
        ' Getting current Extra gaurd time (N)
        lRecLen = 255
        lResult = SCardGetAttrib(hCard, SCARD_ATTR_CURRENT_N, bytRecvAttr, lRecLen)
        If lResult <> SCARD_S_SUCCESS Then
            MsgBox "Failed to get Current extragaurd time"
        Else
            i = 0
            szTemp = ""
            lTemp = 0
            While i < lRecLen
                lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
                i = i + 1
            Wend
            
            szMessage = "Current N          : " + Str(lTemp) + vbNewLine
            Message.Text = Message.Text + szMessage
        End If
        
        If lProtocol = SCARD_PROTOCOL_T1 Then
            '  Getting current character waiting time (CWT)
            lRecLen = 255
            lResult = SCardGetAttrib(hCard, SCARD_ATTR_CURRENT_CWT, bytRecvAttr, lRecLen)
            If lResult <> SCARD_S_SUCCESS Then
                MsgBox "Failed to get Current CWT"
            Else
                i = 0
                szTemp = ""
                lTemp = 0
                While i < lRecLen
                    lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
                    i = i + 1
                Wend
                
                szMessage = "Current CWT    : " + Str(lTemp) + vbNewLine
                Message.Text = Message.Text + szMessage
            End If
            
            '  Getting current Block waiting time (BWT)
            lRecLen = 255
            lResult = SCardGetAttrib(hCard, SCARD_ATTR_CURRENT_BWT, bytRecvAttr, lRecLen)
            If lResult <> SCARD_S_SUCCESS Then
                MsgBox "Failed to get Current BWT"
            Else
                i = 0
                szTemp = ""
                lTemp = 0
                While i < lRecLen
                    lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
                    i = i + 1
                Wend
                
                szMessage = "Current BWT    : " + Str(lTemp) + vbNewLine
                Message.Text = Message.Text + szMessage
            End If
        
            '  Getting current character waiting time (IFSC)
            lRecLen = 255
            lResult = SCardGetAttrib(hCard, SCARD_ATTR_CURRENT_IFSC, bytRecvAttr, lRecLen)
            If lResult <> SCARD_S_SUCCESS Then
                MsgBox "Failed to get Current IFSC"
            Else
                i = 0
                szTemp = ""
                lTemp = 0
                While i < lRecLen
                    lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
                    i = i + 1
                Wend
                
                szMessage = "Current IFSC     : " + Str(lTemp) + vbNewLine
                Message.Text = Message.Text + szMessage
            End If
        Else
            '  Getting current W
            lRecLen = 255
            lResult = SCardGetAttrib(hCard, SCARD_ATTR_CURRENT_IFSC, bytRecvAttr, lRecLen)
            If lResult <> SCARD_S_SUCCESS Then
                MsgBox "Failed to get Current W"
            Else
                i = 0
                szTemp = ""
                lTemp = 0
                While i < lRecLen
                    lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
                    i = i + 1
                Wend
                
                szMessage = "Current W         : " + Str(lTemp) + vbNewLine
                Message.Text = Message.Text + szMessage
            End If
        
        End If            '  lProtocol = SCARD_PROTOCOL_T1
    End If
End Sub
Private Sub BtnTransmit_Click()
    Dim bytCommand As BytArray
    Dim byReadBuffer As BytArray
    Dim lLen As Long
    Dim iReturnlength As Long
    
    Message.Text = ""
    bytCommand = StringToBytArray(CommandCombo.Text)
    If bConversion = False Then Exit Sub
    CommandCombo.AddItem (CommandCombo.Text)
    bConversion = False
    Message.Text = "The result of the command is:  "
    lLen = Len(CommandCombo.Text) / 2
    iReturnlength = 255
    
    lResult = SCardTransmit(hCard, 0, bytCommand, lLen, 0, byReadBuffer, iReturnlength)
    If lResult <> SCARD_S_SUCCESS Then
        MsgBox "Transmit function failed"
        MsgBox "ReturnCode(transmit):  " + Hex(lResult)
    End If
    
    Message.Text = Message.Text + DecimalToString(byReadBuffer, iReturnlength, True)
End Sub

Private Sub butExit_Click()
    Unload Me
End Sub

Private Sub CardConnect_Click()
    Dim lActiveProtocol As Long
    Dim frmCardConnect As frmConnect
    Dim lState As Long
    Dim bAtr As BytArray
    Dim lAtrLen As Long
    Dim szReaderList As String * 256
    Dim i As Integer
    Dim szTemp As String
    
    lResult = 0
    szReaderName = ReaderListCombo.Text
    If szReaderName = "" Then
        MsgBox "Please select a reader"
        Exit Sub
    End If
    
    ' here get the mode choice from the user
    Set frmCardConnect = New frmConnect
    
    lProtocol = -1
    lMode = -1
    Load frmCardConnect
    frmCardConnect.Left = Left + 550
    frmCardConnect.Top = Top + 550
    frmCardConnect.Show 1
    
    If lProtocol = -1 And lMode = -1 Then Exit Sub
    If lMode = SCARD_SHARE_DIRECT Then
        lResult = SCardConnect(hContext, szReaderName, lMode, 0, hCard, lActiveProtocol)
    Else
        lResult = SCardEstablishContext(SCARD_SCOPE_USER, 0, 0, hContext)
        If lResult = SCARD_S_SUCCESS Then
            lResult = SCardConnect(hContext, szReaderName, lMode, lProtocol, hCard, lActiveProtocol)
        Else
            Exit Sub
        End If
    End If
    
    If lResult <> SCARD_S_SUCCESS Then
        If lResult = SCARD_E_UNKNOWN_READER Then
            MsgBox "Invalid Reader Name" + vbNewLine + "Please enter the reader name correctly or select from the list", vbInformation + vbOKOnly
        Else
            MsgBox "CardConnect: " + ErrorToString(lResult)
        End If
        Exit Sub
    End If
    
    lAtrLen = 255

    lResult = SCardStatus(hCard, szReaderList, Len(szReaderList), lState, lProtocol, bAtr, lAtrLen)
       
    Select Case lState
        Case SCARD_ABSENT:
            szMessage = "No card is currently inserted."
        Case SCARD_PRESENT:
            szMessage = "A card is inserted."
        Case SCARD_SWALLOWED:
            szMessage = "A card is inserted and the reader is swallowed."
        Case SCARD_POWERED:
            szMessage = "The card is powered but the reader."
        Case SCARD_NEGOTIABLE:
            szMessage = "A card is inserted and awaits protocol negotiation."
        Case SCARD_SPECIFIC:
            szMessage = "A card is inserted and a protocol has been selected."
        Case Else
            szMessage = "Status: " + lState
    End Select
            
    szMessage = szMessage + vbNewLine
    szMessage = szMessage + "ATR: "
    i = 0
    szMessage = szMessage + DecimalToString(bAtr, lAtrLen, True)

    Select Case lActiveProtocol
        Case SCARD_PROTOCOL_DEFAULT
            szProtocol = "Default "
        Case SCARD_PROTOCOL_RAW
            szProtocol = "Raw "
        Case SCARD_PROTOCOL_T0
            szProtocol = "T=0 "
        Case SCARD_PROTOCOL_T1
            szProtocol = "T=1 "
        Case SCARD_PROTOCOL_UNDEFINED
            szProtocol = "Undefined"
    End Select
    lProtocol = lActiveProtocol
    szMessage = szMessage + vbNewLine + "Active Protocol  : " + szProtocol
    Message.Text = szMessage
    
    CardDisconnect.Enabled = True
    CommandCombo.Enabled = True
    BtnTransmit.Enabled = True
    BtnGetAttrib.Enabled = True
    CardConnect.Enabled = False
    ReaderListCombo.Enabled = False
End Sub

Private Sub CardDisconnect_Click()
    Dim frmTemp As frmDisconnect
    Set frmTemp = New frmDisconnect
    
    Load frmTemp
    frmTemp.Left = Left + 550
    frmTemp.Top = Top + 550
    frmTemp.Show 1
    
    If lDisconnectOption = -1 Then Exit Sub
   
    Message.Text = ""
    CardConnect.Enabled = True
    ReaderListCombo.Enabled = True
    CardDisconnect.Enabled = False
    BtnTransmit.Enabled = False
    CommandCombo.Enabled = False
    BtnGetAttrib.Enabled = False
    
    If hCard <> 0 Then
        lResult = SCardDisconnect(hCard, lDisconnectOption)
        hCard = 0
    End If
End Sub

Private Sub Form_Load()
    Dim mszGroups As String
    Dim szReaderLists As String * 256
    Dim iTemp As Integer
    
    bConversion = False
    lResult = SCardEstablishContext(SCARD_SCOPE_USER, 0, 0, hContext)
    If lResult <> SCARD_S_SUCCESS Then
        MsgBox "Cannot establish connection"
        MsgBox "ReturnCode(ESTACON):  " + Hex(lResult)
    End If
    
    nReaderCount = 255
    lResult = SCardListReaders(hContext, mszGroups, szReaderLists, nReaderCount)
    Call LoadListToControl(ReaderListCombo, szReaderLists)

    iTemp = ReaderListCombo.ListCount
    If iTemp <> 0 Then
        ReaderListCombo.ListIndex = 0
        CardConnect.Enabled = True
        szReaderName = ReaderListCombo.Text
    End If
End Sub

Public Sub LoadListToControl(ByVal Ctrl As ComboBox, ByVal ReaderList As String)
    Dim sTemp As String
    Dim Index As Integer
    
    Index = 1
    sTemp = ""
    Ctrl.Clear
    While (Mid(ReaderList, Index, 1) <> vbNullChar)
        While (Mid(ReaderList, Index, 1) <> vbNullChar)
           sTemp = sTemp + Mid(ReaderList, Index, 1)
           Index = Index + 1
        Wend
        Index = Index + 1
        Ctrl.AddItem sTemp
        sTemp = ""
    Wend
End Sub

Private Sub Form_Terminate()
    If hCard <> 0 Then
        lResult = SCardDisconnect(hCard, SCARD_RESET_CARD)
        hCard = 0
    End If
    If hContext <> 0 Then
        lResult = SCardReleaseContext(hContext)
        hContext = 0
    End If
End Sub

Private Function ErrorToString(dwErrorCode As Long) As String
    Dim szTemp As String
    
    If lResult = SCARD_STATE_UNAVAILABLE Then
        szTemp = "Card Unavailable"
    ElseIf lResult = SCARD_STATE_EMPTY Then
        szTemp = "Empty"
    ElseIf lResult = SCARD_W_REMOVED_CARD Then
        szTemp = "CardRemoved"
    ElseIf lResult = SCARD_E_SHARING_VIOLATION Then
        szTemp = "Scard Sharing Violation"
    ElseIf lResult = SCARD_E_NOT_READY Then
        szTemp = "Scard not ready"
    ElseIf lResult = SCARD_E_PROTO_MISMATCH Then
        szTemp = "Protocol Mismatch"
    ElseIf lResult = SCARD_E_INVALID_VALUE Then
        szTemp = "Invalid Parameter was passed"
    Else
        szTemp = "SCardConnectReturnCode : " + Hex(lResult)
    End If
    ErrorToString = szTemp
End Function

Private Function DecimalToString(byReadBuffer As BytArray, leng As Long, bSpace As Boolean) As String
    Dim i As Integer
    Dim iTemp As Integer
    Dim szTemp As String
    
    szTemp = ""
    i = 0
    While i < leng
        iTemp = byReadBuffer.byBytes(i)
        If (iTemp < 16) Then
            szTemp = szTemp + "0"
        End If
        szTemp = szTemp + Hex(iTemp)
        If bSpace Then
            szTemp = szTemp + " "
        End If
        i = i + 1
    Wend
       DecimalToString = szTemp
End Function

Private Function BytArrayToString(bytArr As BytArray, lLeng As Long) As String
    Dim i As Integer
    Dim szTemp As String
    
    i = 0
    szTemp = ""
    While i < lLeng
        szTemp = szTemp + Chr(bytArr.byBytes(i))
        i = i + 1
    Wend
    
    BytArrayToString = szTemp
End Function
